--- Portfile.save	2007-04-08 23:09:09.000000000 -0400
+++ Portfile	2007-04-08 23:16:27.000000000 -0400
@@ -25,9 +25,9 @@
 startupitem.create	yes
 startupitem.name	dbus
 startupitem.init	XDG_DATA_DIRS=${prefix}/share
-startupitem.start	${prefix}/bin/dbus-daemon --system
-startupitem.stop	kill `cat ${prefix}/var/run/dbus/pid`
-startupitem.restart	"kill `cat ${prefix}/var/run/dbus/pid` ; ${prefix}/bin/dbus-daemon"
+startupitem.start	"${prefix}/bin/dbus-daemon --system"
+startupitem.stop	"kill `cat ${prefix}/var/run/dbus/pid`"
+startupitem.restart	"kill `cat ${prefix}/var/run/dbus/pid` ; ${prefix}/bin/dbus-daemon --system"
 
 pre-patch {
 	file mkdir ${worksrcpath}/m4