diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/C/Compose.pre libX11-X11R7.1-1.0.1/nls/C/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/C/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/C/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/iscii-dev/Compose.pre libX11-X11R7.1-1.0.1/nls/iscii-dev/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/iscii-dev/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/iscii-dev/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/isiri-3342/Compose.pre libX11-X11R7.1-1.0.1/nls/isiri-3342/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/isiri-3342/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/isiri-3342/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/iso8859-11/Compose.pre libX11-X11R7.1-1.0.1/nls/iso8859-11/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/iso8859-11/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/iso8859-11/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/ja.S90/Compose.pre libX11-X11R7.1-1.0.1/nls/ja.S90/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/ja.S90/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/ja.S90/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/ja.U90/Compose.pre libX11-X11R7.1-1.0.1/nls/ja.U90/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/ja.U90/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/ja.U90/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/ja_JP.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/ja_JP.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/ja_JP.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/ja_JP.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/ko_KR.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/ko_KR.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/ko_KR.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/ko_KR.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1251/Compose.pre libX11-X11R7.1-1.0.1/nls/microsoft-cp1251/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1251/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/microsoft-cp1251/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1255/Compose.pre libX11-X11R7.1-1.0.1/nls/microsoft-cp1255/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1255/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/microsoft-cp1255/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1256/Compose.pre libX11-X11R7.1-1.0.1/nls/microsoft-cp1256/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/microsoft-cp1256/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/microsoft-cp1256/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/nokhchi-1/Compose.pre libX11-X11R7.1-1.0.1/nls/nokhchi-1/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/nokhchi-1/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/nokhchi-1/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/tatar-cyr/Compose.pre libX11-X11R7.1-1.0.1/nls/tatar-cyr/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/tatar-cyr/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/tatar-cyr/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/th_TH/Compose.pre libX11-X11R7.1-1.0.1/nls/th_TH/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/th_TH/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/th_TH/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/th_TH.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/th_TH.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/th_TH.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/th_TH.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/tscii-0/Compose.pre libX11-X11R7.1-1.0.1/nls/tscii-0/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/tscii-0/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/tscii-0/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/zh_CN.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/zh_CN.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/zh_CN.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/zh_CN.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/zh_HK.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/zh_HK.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/zh_HK.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/zh_HK.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/zh_TW.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/zh_TW.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/zh_TW.UTF-8/Compose.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/zh_TW.UTF-8/Compose.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/zh_HK.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/zh_HK.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/el_GR.UTF-8/XI18N_OBJS	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/el_GR.UTF-8/XI18N_OBJS	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file
diff -r -u -N --exclude='*.orig' libX11-X11R7.1-1.0.1.orig/nls/zh_HK.UTF-8/Compose.pre libX11-X11R7.1-1.0.1/nls/zh_HK.UTF-8/Compose.pre
--- libX11-X11R7.1-1.0.1.orig/nls/el_GR.UTF-8/XLC_LOCALE.pre	2006-05-12 11:46:51.000000000 -0700
+++ libX11-X11R7.1-1.0.1/nls/el_GR.UTF-8/XLC_LOCALE.pre	2006-11-27 13:05:59.000000000 -0800
@@ -0,0 +1 @@
+XCOMM dummy file