--- configure.orig	2007-11-25 17:43:30.000000000 -0700
+++ configure	2007-12-01 15:44:06.000000000 -0700
@@ -12450,71 +12450,6 @@
   CLIENT_LIBS="-lsocket $CLIENT_LIBS"
 fi
 
-      { echo "$as_me:$LINENO: checking for gethostbyaddr in -lbind" >&5
-echo $ECHO_N "checking for gethostbyaddr in -lbind... $ECHO_C" >&6; }
-if test "${ac_cv_lib_bind_gethostbyaddr+set}" = set; then
-  echo $ECHO_N "(cached) $ECHO_C" >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lbind  $LIBS"
-cat >conftest.$ac_ext <<_ACEOF
-/* confdefs.h.  */
-_ACEOF
-cat confdefs.h >>conftest.$ac_ext
-cat >>conftest.$ac_ext <<_ACEOF
-/* end confdefs.h.  */
-
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char gethostbyaddr ();
-int
-main ()
-{
-return gethostbyaddr ();
-  ;
-  return 0;
-}
-_ACEOF
-rm -f conftest.$ac_objext conftest$ac_exeext
-if { (ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
-  (eval "$ac_link") 2>conftest.er1
-  ac_status=$?
-  grep -v '^ *+' conftest.er1 >conftest.err
-  rm -f conftest.er1
-  cat conftest.err >&5
-  echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); } && {
-	 test -z "$ac_c_werror_flag" ||
-	 test ! -s conftest.err
-       } && test -s conftest$ac_exeext &&
-       $as_test_x conftest$ac_exeext; then
-  ac_cv_lib_bind_gethostbyaddr=yes
-else
-  echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-	ac_cv_lib_bind_gethostbyaddr=no
-fi
-
-rm -f core conftest.err conftest.$ac_objext conftest_ipa8_conftest.oo \
-      conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
-fi
-{ echo "$as_me:$LINENO: result: $ac_cv_lib_bind_gethostbyaddr" >&5
-echo "${ECHO_T}$ac_cv_lib_bind_gethostbyaddr" >&6; }
-if test $ac_cv_lib_bind_gethostbyaddr = yes; then
-  CLIENT_LIBS="-lbind $CLIENT_LIBS"
-fi
-
 
     elif test "$client" = "sdl"; then
       { { echo "$as_me:$LINENO: error: specified client 'sdl' not configurable (SDL >= 1.1.4 is needed (www.libsdl.org))" >&5
@@ -16668,7 +16603,7 @@
 do
   for j in $libggz_header;
   do
-    echo "configure: 16671: $i/$j" >&5
+    echo "configure: 16606: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       libggz_incdir=$i
@@ -16951,7 +16886,7 @@
 do
   for j in $ggzmod_header;
   do
-    echo "configure: 16954: $i/$j" >&5
+    echo "configure: 16889: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggzmod_incdir=$i
@@ -17081,7 +17016,7 @@
 do
   for j in ggz-config;
   do
-    echo "configure: 17084: $i/$j" >&5
+    echo "configure: 17019: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggz_config_dir=$i
@@ -17318,7 +17253,7 @@
 do
   for j in $ggz_gtk_header;
   do
-    echo "configure: 17321: $i/$j" >&5
+    echo "configure: 17256: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggz_gtk_incdir=$i
@@ -17516,7 +17451,7 @@
 do
   for j in $libggz_header;
   do
-    echo "configure: 17519: $i/$j" >&5
+    echo "configure: 17454: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       libggz_incdir=$i
@@ -17798,7 +17733,7 @@
 do
   for j in $ggzdmod_header;
   do
-    echo "configure: 17801: $i/$j" >&5
+    echo "configure: 17736: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggzdmod_incdir=$i
@@ -18107,7 +18042,7 @@
 do
   for j in $libggz_header;
   do
-    echo "configure: 18110: $i/$j" >&5
+    echo "configure: 18045: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       libggz_incdir=$i
@@ -18390,7 +18325,7 @@
 do
   for j in $ggzmod_header;
   do
-    echo "configure: 18393: $i/$j" >&5
+    echo "configure: 18328: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggzmod_incdir=$i
@@ -18520,7 +18455,7 @@
 do
   for j in ggz-config;
   do
-    echo "configure: 18523: $i/$j" >&5
+    echo "configure: 18458: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggz_config_dir=$i
@@ -18757,7 +18692,7 @@
 do
   for j in $ggz_gtk_header;
   do
-    echo "configure: 18760: $i/$j" >&5
+    echo "configure: 18695: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggz_gtk_incdir=$i
@@ -18955,7 +18890,7 @@
 do
   for j in $libggz_header;
   do
-    echo "configure: 18958: $i/$j" >&5
+    echo "configure: 18893: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       libggz_incdir=$i
@@ -19237,7 +19172,7 @@
 do
   for j in $ggzdmod_header;
   do
-    echo "configure: 19240: $i/$j" >&5
+    echo "configure: 19175: $i/$j" >&5
     if test -r "$i/$j"; then
       echo "taking that" >&5
       ggzdmod_incdir=$i
@@ -19514,71 +19449,6 @@
 
 
 if test x$server = xtrue; then
-        { echo "$as_me:$LINENO: checking for gethostbyaddr in -lbind" >&5
-echo $ECHO_N "checking for gethostbyaddr in -lbind... $ECHO_C" >&6; }
-if test "${ac_cv_lib_bind_gethostbyaddr+set}" = set; then
-  echo $ECHO_N "(cached) $ECHO_C" >&6
-else
-  ac_check_lib_save_LIBS=$LIBS
-LIBS="-lbind  $LIBS"
-cat >conftest.$ac_ext <<_ACEOF
-/* confdefs.h.  */
-_ACEOF
-cat confdefs.h >>conftest.$ac_ext
-cat >>conftest.$ac_ext <<_ACEOF
-/* end confdefs.h.  */
-
-/* Override any GCC internal prototype to avoid an error.
-   Use char because int might match the return type of a GCC
-   builtin and then its argument prototype would still apply.  */
-#ifdef __cplusplus
-extern "C"
-#endif
-char gethostbyaddr ();
-int
-main ()
-{
-return gethostbyaddr ();
-  ;
-  return 0;
-}
-_ACEOF
-rm -f conftest.$ac_objext conftest$ac_exeext
-if { (ac_try="$ac_link"
-case "(($ac_try" in
-  *\"* | *\`* | *\\*) ac_try_echo=\$ac_try;;
-  *) ac_try_echo=$ac_try;;
-esac
-eval "echo \"\$as_me:$LINENO: $ac_try_echo\"") >&5
-  (eval "$ac_link") 2>conftest.er1
-  ac_status=$?
-  grep -v '^ *+' conftest.er1 >conftest.err
-  rm -f conftest.er1
-  cat conftest.err >&5
-  echo "$as_me:$LINENO: \$? = $ac_status" >&5
-  (exit $ac_status); } && {
-	 test -z "$ac_c_werror_flag" ||
-	 test ! -s conftest.err
-       } && test -s conftest$ac_exeext &&
-       $as_test_x conftest$ac_exeext; then
-  ac_cv_lib_bind_gethostbyaddr=yes
-else
-  echo "$as_me: failed program was:" >&5
-sed 's/^/| /' conftest.$ac_ext >&5
-
-	ac_cv_lib_bind_gethostbyaddr=no
-fi
-
-rm -f core conftest.err conftest.$ac_objext conftest_ipa8_conftest.oo \
-      conftest$ac_exeext conftest.$ac_ext
-LIBS=$ac_check_lib_save_LIBS
-fi
-{ echo "$as_me:$LINENO: result: $ac_cv_lib_bind_gethostbyaddr" >&5
-echo "${ECHO_T}$ac_cv_lib_bind_gethostbyaddr" >&6; }
-if test $ac_cv_lib_bind_gethostbyaddr = yes; then
-  SERVER_LIBS="-lbind $SERVER_LIBS"
-fi
-
 
 
         if test "$WITH_READLINE" = "yes" || test "$WITH_READLINE" = "maybe"; then