From 2c4b0f9615b646712609ebef3c0851c9a22e781b Mon Sep 17 00:00:00 2001
From: Jeremy Huddleston <jeremyhu@freedesktop.org>
Date: Fri, 17 Oct 2008 09:25:26 -0700
Subject: [PATCH 07/16] XQuartz: Fixed missing key-equiv for Hide-Others.

---
 .../English.lproj/main.nib/designable.nib          |    9 +++------
 .../English.lproj/main.nib/keyedobjects.nib        |  Bin 41243 -> 41183 bytes
 2 files changed, 3 insertions(+), 6 deletions(-)

diff --git hw/xquartz/bundle/Resources/English.lproj/main.nib/designable.nib hw/xquartz/bundle/Resources/English.lproj/main.nib/designable.nib
index 7490e0f..58a1336 100644
--- hw/xquartz/bundle/Resources/English.lproj/main.nib/designable.nib
+++ hw/xquartz/bundle/Resources/English.lproj/main.nib/designable.nib
@@ -8,8 +8,6 @@
 		<string key="IBDocument.HIToolboxVersion">352.00</string>
 		<object class="NSMutableArray" key="IBDocument.EditedObjectIDs">
 			<bool key="EncodedWithXMLCoder">YES</bool>
-			<integer value="57"/>
-			<integer value="348"/>
 		</object>
 		<object class="NSArray" key="IBDocument.PluginDependencies">
 			<bool key="EncodedWithXMLCoder">YES</bool>
@@ -151,8 +149,8 @@
 								<object class="NSMenuItem" id="206802571">
 									<reference key="NSMenu" ref="576521955"/>
 									<string key="NSTitle">Hide Others</string>
-									<string key="NSKeyEquiv"/>
-									<int key="NSKeyEquivModMask">1048576</int>
+									<string key="NSKeyEquiv">h</string>
+									<int key="NSKeyEquivModMask">1572864</int>
 									<int key="NSMnemonicLoc">2147483647</int>
 									<reference key="NSOnImage" ref="531645050"/>
 									<reference key="NSMixedImage" ref="351811234"/>
@@ -402,7 +400,7 @@
 				<string key="NSWindowContentMaxSize">{3.40282e+38, 3.40282e+38}</string>
 				<string key="NSWindowContentMinSize">{320, 240}</string>
 				<object class="NSView" key="NSWindowView" id="941366957">
-					<reference key="NSNextResponder"/>
+					<nil key="NSNextResponder"/>
 					<int key="NSvFlags">256</int>
 					<object class="NSMutableArray" key="NSSubviews">
 						<bool key="EncodedWithXMLCoder">YES</bool>
@@ -1197,7 +1195,6 @@ d2hpY2ggbWF5IHByZXZlbnQgWDExIGFwcGxpY2F0aW9ucyBmcm9tIGxhdW5jaGluZy4</string>
 						</object>
 					</object>
 					<string key="NSFrameSize">{484, 308}</string>
-					<reference key="NSSuperview"/>
 				</object>
 				<string key="NSScreenRect">{{0, 0}, {1280, 938}}</string>
 				<string key="NSMinSize">{320, 262}</string>
diff --git hw/xquartz/bundle/Resources/English.lproj/main.nib/keyedobjects.nib hw/xquartz/bundle/Resources/English.lproj/main.nib/keyedobjects.nib
index c5495681f7ad006cf29ac967f52dc804128570ec..1b5aa883837866fb71c08f609f051515b0c6547d 100644
GIT binary patch
-- 
1.6.1